// Generated from net_conf.json. Do not edit!
#ifndef CNI_NET_CONF_SCHEMA_H
#define CNI_NET_CONF_SCHEMA_H

#include <sys/types.h>
#include <stdint.h>
#include "json_common.h"
#include "cni_network_route.h"
#include "cni_network_dns.h"
#include "cni_net_args.h"
#include "defs.h"
#include "cni_result_curr.h"
#include "cni_network_interface.h"
#include "cni_network_ipconfig.h"
#include "cni_network_ipconfig_020.h"
#include "cni_inner_port_mapping.h"
#include "cni_ip_ranges.h"
#include "cni_bandwidth_entry.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    char *subnet;
    char *range_start;
    char *range_end;
    char *gateway;
}
cni_net_conf_ipam_ranges_element;

void free_cni_net_conf_ipam_ranges_element (cni_net_conf_ipam_ranges_element *ptr);

cni_net_conf_ipam_ranges_element *make_cni_net_conf_ipam_ranges_element (yajl_val tree, const struct parser_context *ctx, parser_error *err);

typedef struct {
    char *type;

    cni_network_route **routes;
    size_t routes_len;

    cni_net_conf_ipam_ranges_element ***ranges;
    size_t *ranges_item_lens;
    size_t ranges_len;

    yajl_val _residual;
}
cni_net_conf_ipam;

void free_cni_net_conf_ipam (cni_net_conf_ipam *ptr);

cni_net_conf_ipam *make_cni_net_conf_ipam (yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_cni_net_conf_ipam (yajl_gen g, const cni_net_conf_ipam *ptr, const struct parser_context *ctx, parser_error *err);

typedef struct {
    char **searches;
    size_t searches_len;

    char **servers;
    size_t servers_len;

    yajl_val _residual;
}
cni_net_conf_runtime_config_dns;

void free_cni_net_conf_runtime_config_dns (cni_net_conf_runtime_config_dns *ptr);

cni_net_conf_runtime_config_dns *make_cni_net_conf_runtime_config_dns (yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_cni_net_conf_runtime_config_dns (yajl_gen g, const cni_net_conf_runtime_config_dns *ptr, const struct parser_context *ctx, parser_error *err);

typedef struct {
    cni_inner_port_mapping **port_mappings;
    size_t port_mappings_len;

    cni_ip_ranges ***ip_ranges;
    size_t *ip_ranges_item_lens;
    size_t ip_ranges_len;

    cni_bandwidth_entry *bandwidth;

    cni_net_conf_runtime_config_dns *dns;

    char **ips;
    size_t ips_len;

    char *mac;

    char *infiniband_guid;

    char *device_id;

    yajl_val _residual;
}
cni_net_conf_runtime_config;

void free_cni_net_conf_runtime_config (cni_net_conf_runtime_config *ptr);

cni_net_conf_runtime_config *make_cni_net_conf_runtime_config (yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_cni_net_conf_runtime_config (yajl_gen g, const cni_net_conf_runtime_config *ptr, const struct parser_context *ctx, parser_error *err);

typedef struct {
    char *cni_version;

    char *name;

    char *type;

    char *bridge;

    bool is_gateway;

    bool ip_masq;

    bool hairpin_mode;

    cni_net_conf_ipam *ipam;

    cni_network_dns *dns;

    char *domain_name;

    cni_net_args *args;

    cni_result_curr *prev_result;

    cni_net_conf_runtime_config *runtime_config;

    json_map_string_bool *capabilities;

    yajl_val _residual;
}
cni_net_conf;

void free_cni_net_conf (cni_net_conf *ptr);

cni_net_conf *make_cni_net_conf (yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_cni_net_conf (yajl_gen g, const cni_net_conf *ptr, const struct parser_context *ctx, parser_error *err);

cni_net_conf *cni_net_conf_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err);

cni_net_conf *cni_net_conf_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err);

cni_net_conf *cni_net_conf_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err);

char *cni_net_conf_generate_json(const cni_net_conf *ptr, const struct parser_context *ctx, parser_error *err);

#ifdef __cplusplus
}
#endif

#endif

